# Copyright 2005 James Bunton <james@delx.cjb.net>
# Licensed for distribution under the GPL version 2, check COPYING for details

from tlib import xmlw

import utils
import config
import xdb

import shutil
import os
import os.path


X = os.path.sep

def init():
	global noteList
	global noteListF

	try:
		notes = NotesToMyself()
		for note in noteList:
			if notes.check(note):
				noteListF[noteList.index(note)]()
				notes.append(note)
		notes.save()
	except:
		print "An error occurred during one of the automatic data update routines. Please report this bug."
		raise


class NotesToMyself:
	def __init__(self):
		pre = os.path.abspath(config.spooldir) + X + config.jid + X
		self.filename = pre + X + "notes_to_myself"
		self.notes = []
		
		if os.path.exists(self.filename):
			f = open(self.filename, "r")
			self.notes = [x.strip() for x in f.readlines()]
			f.close()
		else:
			if not os.path.exists(pre):
				os.makedirs(pre)
			global noteList
			self.notes = noteList
	
	def check(self, note):
		return self.notes.count(note) == 0
	
	def append(self, note):
		if self.check(note):
			self.notes.append(note)

	def save(self):
		f = open(self.filename, "w")
		for note in self.notes:
			f.write(note + "\n")
		f.close()



def doSpoolPrepCheck():
	pre = os.path.abspath(config.spooldir) + X + config.jid + X

	print "Checking spool files and stringprepping any if necessary...",

	for file in os.listdir(pre):
		try:
			file = xdb.unmangle(file).decode("utf-8")
			filej = xmlw.jid.intern(file).full()
			if(file != filej):
				file = xdb.mangle(file)
				filej = xdb.mangle(filej)
				if(os.path.exists(filej)):
					print "Need to move", file, "to", filej, "but the latter exists!\nAborting!"
					os.exit(1)
				else:
					shutil.move(pre + file, pre + filej)
		except:
			print "File: " + file
			raise
	print "done"


def doHashDirUpgrade():
	print "Upgrading your XDB structure to use hashed directories for speed...",

	# Do avatars...
	pre = os.path.join(os.path.abspath(config.spooldir), config.jid) + X + "avatars" + X
	if os.path.exists(pre):
		for file in os.listdir(pre):
			try:
				if os.path.isfile(pre + file):
					pre2 = pre + file[0:3] + X
					if not os.path.exists(pre2):
						os.makedirs(pre2)
					shutil.move(pre + file, pre2 + file)
			except:
				print "File: " + file
				raise
	
	# Do spool files...
	pre = os.path.join(os.path.abspath(config.spooldir), config.jid) + X
	if os.path.exists(pre):
		for file in os.listdir(pre):
			try:
				if os.path.isfile(pre + file) and file != "notes_to_myself":
					hash = file[0:2]
					pre2 = pre + hash + X
					if not os.path.exists(pre2):
						os.makedirs(pre2)

					if(os.path.exists(pre2 + file)):
						print "Need to move", file, "to", pre2 + file, "but the latter exists!\nAborting!"
						os.exit(1)
					else:
						shutil.move(pre + file, pre2 + file)
			except:
				print "File: " + file

	print "done"



noteList = ["doSpoolPrepCheck", "doHashDirUpgrade"]
noteListF = [doSpoolPrepCheck, doHashDirUpgrade]

